-- ForteXorcist v1.957 by Xus 13-01-2010
-- Forte Mage Module attempt by Amros of Gilneas

if FW.CLASS == "MAGE" then
	local FW = FW;
	local FWL = FW.L;
	local MG = FW:ClassModule("Mage");

	if FW.Modules.Timer then

		-- istype: FW.DEFAULT FW.SHARED FW.UNIQUE FW.PET FW.CHARM FW.COOLDOWN FW.HEAL FW.BUFF
		--spell, hastarget, duration, isdot, istype, reducedinpvp, texture, stack
	
		FW:RegisterSpell(58537,1,050,0,FW.UNIQUE,010); -- Polymorph
			FW:RegisterSpellModRank(58537,	1, -30);
			FW:RegisterSpellModRank(58537,	2, -20);
			FW:RegisterSpellModRank(58537,	3, -10);
		FW:RegisterSpell(55361,1,012,1,FW.DEFAULT); -- living bomb
		FW:RegisterSpell(12848,1,004,1,FW.DEFAULT); -- ignite
			FW:RegisterTickSpeed(12848, 1); -- set tick speed to 1 instead of 3
		FW:RegisterSpell(42833,1,000,0,FW.DEFAULT); -- fireball
			FW:RegisterTickSpeed(42833, 2); -- set tick speed to 2 instead of 3	
			
		FW:RegisterSpell(31589,1,000,0,FW.UNIQUE); -- slow
		FW:RegisterSpell(42931,0,008,0,FW.UNIQUE); -- cone of cold
		FW:RegisterSpell(42917,0,008,0,FW.UNIQUE); -- frost nova
		FW:RegisterSpell(44572,1,005,0,FW.UNIQUE); -- deep freeze
		
		FW:RegisterSpell(12497,1,005,0,FW.DEFAULT); -- frostbite
		
		FW:RegisterSpell(55342,0,030,0,FW.UNIQUE); -- Mirror Image
		FW:RegisterSpell(12486,1,000,0,FW.DEFAULT); -- chill
		
		FW:RegisterBuff(34754); -- Clearcasting
		FW:RegisterBuff(48108); -- Hot Streak
		FW:RegisterBuff(37445);	-- Mana Surge
		
		--FW:RegisterBuff(36032); -- Arcane Blast
		
		FW:RegisterBuff(12042); -- Arcane Power
		FW:RegisterBuff(43020); -- Mana Shield
		FW:RegisterBuff(43010); -- Fire Ward
		FW:RegisterBuff(43012); -- Frost Ward
		FW:RegisterBuff(12472); -- Icy Veins
		FW:RegisterBuff(54490); -- Missile Barrage
		FW:RegisterBuff(57761); -- Fireball!
		FW:RegisterBuff(70753); -- Pushing the Limit
		
		-- self debuffs
		FW:RegisterSelfDebuff(36032); -- Arcane Blast

		--debuffs
		FW:RegisterDebuff(42931); -- cone of cold
		FW:RegisterDebuff(42917); -- frost nova

		FW:RegisterCasterBuffs();
	end
	if FW.Modules.Cooldown then
		FW:RegisterCasterPowerupCooldowns();
	end
	if FW.Modules.Timer then
		local poly = FW:SpellName(58537);
		FW:RegisterOnTimerBreak(function(unit,mark,spell)
			if spell == poly then
				if mark~=0 then unit=FW.RaidIcons[mark]..unit;end
				FW:CastShow("PolymorphBreak",unit);
			end
		end);
		FW:RegisterOnTimerFade(function(unit,mark,spell,t)
			if spell == poly then
				if t <= FW:GetFadeTime("PolymorphFade") then
					if mark~=0 then unit=FW.RaidIcons[mark]..unit;end
					FW:CastShow("PolymorphFade",unit);
					return 1;
				end
			end
		end);
	end
	FW:SetMainCategory(FWL.RAID_MESSAGES,FW.ICON_MESSAGE,10,"RAIDMESSAGES");
	FW:SetSubCategory(FW.NIL,FW.NIL,1);
	FW:RegisterOption(FW.INF,2,FW.NON,FWL.RAID_MESSAGES_HINT1);
	FW:RegisterOption(FW.INF,2,FW.NON,FWL.RAID_MESSAGES_HINT2);
	FW:RegisterOption(FW.CHK,2,FW.NON,FWL.SHOW_IN_RAID,		FWL.SHOW_IN_RAID_TT,    "OutputRaid");
	FW:RegisterOption(FW.MSG,2,FW.NON,FWL.SHOW_IN_CHANNEL,	FWL.SHOW_IN_CHANNEL_TT,	"Output");

	if FW.Modules.Timer then
		FW:SetSubCategory(FWL.BREAK_FADE,FW.ICON_SPECIFIC,2);
		FW:RegisterOption(FW.INF,2,FW.NON,FWL.BREAK_FADE_HINT1);
		FW:RegisterOption(FW.MS2,2,FW.NON,FWL.POLYMORPH_BREAK,		"",    "PolymorphBreak");
		FW:RegisterOption(FW.MS2,2,FW.NON,FWL.POLYMORPH_FADE,		"",    "PolymorphFade");
	end

	FW.Default.OutputRaid = true;
	FW.Default.Output = true;
	FW.Default.OutputMsg = "MyProMageChannel";

	FW.Default.PolymorphBreak = 0;	FW.Default.PolymorphBreakMsg = ">> Polymorph on %s Broke Early! <<";
	FW.Default.PolymorphFade = 0;	FW.Default.PolymorphFadeMsg = ">> Polymorph on %s Fading in 3 seconds! <<";

end